// BOLT SYSTEM FOR 48 MHZ,
// 18F2550, C18 COMPILER V3.40, MPLAB V8.63
// Implementation Project BOLT SYSTEM REMOTE CONTROL
// via the serial port. Connect Bolt module with PC
// with a serial cable or USB to Serial
// TEST program using a terminal emulator,
// CONFIGURATION SOFTWARE HYPERTERMINAL 9600, N, 8,1
// Sends "0K>" TO PC and waits for a user command:
// COMMAND R1 => ON RELAY,
// COMMAND R0 => OFF RELAY
// COMMAND T => Send "TIME ="
// The user must type in seconds (maximum 255)
// THE TIME RELAY WANTED TO ACTIVATE, FINISHING
// The number with a CR.
// COMMAND S
// Write the decimal value of the four microswitches (0..15),
// "S=12" (EXAMPLE)
// After executing each command sends "OK>"

#include <p18cxxx.h>
#include <delays.h>
#include <usart.h>
#include <stdio.h>
#include <stdlib.h>
#include "18F2550BOLT.h"

extern void _startup( void ); 
#pragma code _RESET_INTERRUPT_VECTOR = 0x000800 
void _reset( void ) 
{ 
    _asm goto _startup _endasm 
} 
#pragma code

void retraso(int a);
char getECO(void);

char a,b;
char array[10];
int TIEMPO;

void main(void)
{
init_bolt();
OpenUSART(USART_TX_INT_OFF & USART_RX_INT_ON &
USART_ASYNCH_MODE & USART_EIGHT_BIT &
USART_CONT_RX & USART_BRGH_LOW, 77);				//SPBRG = 77 PARA 9600 BPS
	
	while(1)
	{
	printf("\r\n");
	printf("OK>");
	a=getECO();
		if(a=='R')
			{
			b=getECO();
			if (b=='0'){RELE=0;}
			if (b=='1'){RELE=1;}
			}

		if(a=='T')
			{
			printf("\r\nTIME=");
				for(a=0;a<5;a++)		//RECIBE NUMERO TERMINA CON "CR"
				{
				array[a]=getECO();
					if (array[a]==13)goto wo;	//13="CR"
				}
					
			wo:
			array[a]=0;				//caracter null
			TIEMPO=atoi(array);		//convierte a int
			printf("\r\n%u SECONDS",TIEMPO);
			RELE=1;
			retraso(TIEMPO);
			RELE=0;
			}

		if(a=='S')
			{
			b=microsw();
			printf("\r\nS=%d",b);
			}
	}

}

/*FUNCION RETRASO PARAMETRO EN SEGUNDOS*/
void retraso(int a)
{
int b;
for(b=0;b<a;b++)
{delay_ms(1000);}
}

/*FUNCION ESPERA UN CARACTER DEL PUERTO SERIAL, LO LEE Y ENVIA EL ECO*/
/*REGRESA CON EL VALOR DEL CARACTER LEIDO*/
char getECO(void)
{
char a;				
	while (!DataRdyUSART());			//ESPERA BANDERA LISTA
	{
	a=getcUSART();						//LEE UN CARACTER DEL USART
	putcUSART(a);						//ENVIA EL ECO
	}
return a;								//REGRESA DE LA FUNCION CON CARACTER LEIDO
}



			

